import { FieldInfo } from 'model-util-base'
import { ConditionUtil, ConditionUtilImpl, FieldUtil, TableUtilImpl, IdType, JoinTable, SubTable } from 'model-util'
import { Container, Singleton } from 'typescript-ioc' 
import { DevopsTaskLog } from '../models/index' 

import {DevopsTaskMU} from './DevopsTask' 
import {DevopsUserMU} from './DevopsUser' 


/**
 * @author auto generate
 * @version 1.0
 * @date 2021-06-08 17:07
 */
interface DevopsTaskLogCU extends ConditionUtil<DevopsTaskLogCU>{
    ID:FieldUtil<DevopsTaskLogCU>;
    TASK_ID:FieldUtil<DevopsTaskLogCU>;
    RUN_TAG:FieldUtil<DevopsTaskLogCU>;
    RUN_RESULT:FieldUtil<DevopsTaskLogCU>;
    CONTENT:FieldUtil<DevopsTaskLogCU>;
    START_TIME:FieldUtil<DevopsTaskLogCU>;
    FINAL_TIME:FieldUtil<DevopsTaskLogCU>;
    OPERATOR_USER_ID:FieldUtil<DevopsTaskLogCU>;
    CREATE_USER_ID:FieldUtil<DevopsTaskLogCU>;
    UPDATE_USER_ID:FieldUtil<DevopsTaskLogCU>;
    CREATE_TIME:FieldUtil<DevopsTaskLogCU>;
    UPDATE_TIME:FieldUtil<DevopsTaskLogCU>;
}

class DevopsTaskLogCUImpl extends ConditionUtilImpl<DevopsTaskLogCUImpl> implements DevopsTaskLogCU{ 
    newInstance(): DevopsTaskLogCUImpl {
        return new DevopsTaskLogCUImpl();
    } 
    get ID(): FieldUtil<DevopsTaskLogCU>{  
        return new FieldUtil('id','id','主键', this);
    }
    get TASK_ID(): FieldUtil<DevopsTaskLogCU>{  
        return new FieldUtil('task_id','taskId','任务id', this);
    }
    get RUN_TAG(): FieldUtil<DevopsTaskLogCU>{  
        return new FieldUtil('run_tag','runTag','', this);
    }
    get RUN_RESULT(): FieldUtil<DevopsTaskLogCU>{  
        return new FieldUtil('run_result','runResult','运行结果', this);
    }
    get CONTENT(): FieldUtil<DevopsTaskLogCU>{  
        return new FieldUtil('content','content','运行日志信息', this);
    }
    get START_TIME(): FieldUtil<DevopsTaskLogCU>{  
        return new FieldUtil('start_time','startTime','运行开始时间', this);
    }
    get FINAL_TIME(): FieldUtil<DevopsTaskLogCU>{  
        return new FieldUtil('final_time','finalTime','运行结束时间', this);
    }
    get OPERATOR_USER_ID(): FieldUtil<DevopsTaskLogCU>{  
        return new FieldUtil('operator_user_id','operatorUserId','调度人；admin:表示系统调度', this);
    }
    get CREATE_USER_ID(): FieldUtil<DevopsTaskLogCU>{  
        return new FieldUtil('create_user_id','createUserId','创建人id', this);
    }
    get UPDATE_USER_ID(): FieldUtil<DevopsTaskLogCU>{  
        return new FieldUtil('update_user_id','updateUserId','修改人id', this);
    }
    get CREATE_TIME(): FieldUtil<DevopsTaskLogCU>{  
        return new FieldUtil('create_time','createTime','创建时间', this);
    }
    get UPDATE_TIME(): FieldUtil<DevopsTaskLogCU>{  
        return new FieldUtil('update_time','updateTime','更新时间', this);
    }
    get TASK_NAME(): FieldInfo{  
        return new FieldInfo('taskName','任务名称');
    }
    get CREATE_USER_NAME(): FieldInfo{  
        return new FieldInfo('createUserName','');
    }
}

@Singleton 
class DevopsTaskLogMU extends TableUtilImpl<DevopsTaskLogCU,DevopsTaskLog>{ 
    tableName  = 'devops_task_log';
    tableFields  = ['id','task_id','run_tag','run_result','content','start_time','final_time','operator_user_id','create_user_id','update_user_id','create_time','update_time'];
    modelFields  = ['id','taskId','runTag','runResult','content','startTime','finalTime','operatorUserId','createUserId','updateUserId','createTime','updateTime','taskName','createUserName'];
    modelIdFields  = ['id'];
    tableIdFields  = ['id'];
    idType = IdType.CUSTOM;
    joinTables = [{
            joinByDefault: true,
            foreignKeyFields: [DevopsTaskLogMU.TASK_ID],
            joinIdFields: [DevopsTaskMU.ID],
            getTableUtil: ()=>{
                return Container.get(DevopsTaskMU);
            },
            fields: [
                {
                    fieldUtil: DevopsTaskMU.TASK_NAME,
                    alias: 'taskName'
                }
            ]

        } as JoinTable

        ,{
            joinByDefault: true,
            foreignKeyFields: [DevopsTaskLogMU.CREATE_USER_ID],
            joinIdFields: [DevopsUserMU.ID],
            getTableUtil: ()=>{
                return Container.get(DevopsUserMU);
            },
            fields: [
                {
                    fieldUtil: DevopsUserMU.NAME,
                    alias: 'createUserName'
                }
            ]

        } as JoinTable

];
    subTables = [];

    createConditionUtil(): DevopsTaskLogCU {
        return new DevopsTaskLogCUImpl();
    }   

    static get ID(): FieldUtil<DevopsTaskLogCU>{ 
        return new FieldUtil('id','id','主键', new DevopsTaskLogCUImpl());
    }
    static get TASK_ID(): FieldUtil<DevopsTaskLogCU>{ 
        return new FieldUtil('task_id','taskId','任务id', new DevopsTaskLogCUImpl());
    }
    static get RUN_TAG(): FieldUtil<DevopsTaskLogCU>{ 
        return new FieldUtil('run_tag','runTag','', new DevopsTaskLogCUImpl());
    }
    static get RUN_RESULT(): FieldUtil<DevopsTaskLogCU>{ 
        return new FieldUtil('run_result','runResult','运行结果', new DevopsTaskLogCUImpl());
    }
    static get CONTENT(): FieldUtil<DevopsTaskLogCU>{ 
        return new FieldUtil('content','content','运行日志信息', new DevopsTaskLogCUImpl());
    }
    static get START_TIME(): FieldUtil<DevopsTaskLogCU>{ 
        return new FieldUtil('start_time','startTime','运行开始时间', new DevopsTaskLogCUImpl());
    }
    static get FINAL_TIME(): FieldUtil<DevopsTaskLogCU>{ 
        return new FieldUtil('final_time','finalTime','运行结束时间', new DevopsTaskLogCUImpl());
    }
    static get OPERATOR_USER_ID(): FieldUtil<DevopsTaskLogCU>{ 
        return new FieldUtil('operator_user_id','operatorUserId','调度人；admin:表示系统调度', new DevopsTaskLogCUImpl());
    }
    static get CREATE_USER_ID(): FieldUtil<DevopsTaskLogCU>{ 
        return new FieldUtil('create_user_id','createUserId','创建人id', new DevopsTaskLogCUImpl());
    }
    static get UPDATE_USER_ID(): FieldUtil<DevopsTaskLogCU>{ 
        return new FieldUtil('update_user_id','updateUserId','修改人id', new DevopsTaskLogCUImpl());
    }
    static get CREATE_TIME(): FieldUtil<DevopsTaskLogCU>{ 
        return new FieldUtil('create_time','createTime','创建时间', new DevopsTaskLogCUImpl());
    }
    static get UPDATE_TIME(): FieldUtil<DevopsTaskLogCU>{ 
        return new FieldUtil('update_time','updateTime','更新时间', new DevopsTaskLogCUImpl());
    }
    static get TASK_NAME(): FieldInfo{  
        return new FieldInfo('taskName','任务名称');
    }
    static get CREATE_USER_NAME(): FieldInfo{  
        return new FieldInfo('createUserName','');
    }

    get ID(): FieldUtil<DevopsTaskLogCU>{ 
        return DevopsTaskLogMU.ID;
    }
    get TASK_ID(): FieldUtil<DevopsTaskLogCU>{ 
        return DevopsTaskLogMU.TASK_ID;
    }
    get RUN_TAG(): FieldUtil<DevopsTaskLogCU>{ 
        return DevopsTaskLogMU.RUN_TAG;
    }
    get RUN_RESULT(): FieldUtil<DevopsTaskLogCU>{ 
        return DevopsTaskLogMU.RUN_RESULT;
    }
    get CONTENT(): FieldUtil<DevopsTaskLogCU>{ 
        return DevopsTaskLogMU.CONTENT;
    }
    get START_TIME(): FieldUtil<DevopsTaskLogCU>{ 
        return DevopsTaskLogMU.START_TIME;
    }
    get FINAL_TIME(): FieldUtil<DevopsTaskLogCU>{ 
        return DevopsTaskLogMU.FINAL_TIME;
    }
    get OPERATOR_USER_ID(): FieldUtil<DevopsTaskLogCU>{ 
        return DevopsTaskLogMU.OPERATOR_USER_ID;
    }
    get CREATE_USER_ID(): FieldUtil<DevopsTaskLogCU>{ 
        return DevopsTaskLogMU.CREATE_USER_ID;
    }
    get UPDATE_USER_ID(): FieldUtil<DevopsTaskLogCU>{ 
        return DevopsTaskLogMU.UPDATE_USER_ID;
    }
    get CREATE_TIME(): FieldUtil<DevopsTaskLogCU>{ 
        return DevopsTaskLogMU.CREATE_TIME;
    }
    get UPDATE_TIME(): FieldUtil<DevopsTaskLogCU>{ 
        return DevopsTaskLogMU.UPDATE_TIME;
    }
    get TASK_NAME(): FieldInfo{  
        return DevopsTaskLogMU.TASK_NAME;
    }
    get CREATE_USER_NAME(): FieldInfo{  
        return DevopsTaskLogMU.CREATE_USER_NAME;
    }
}
export {DevopsTaskLogMU, DevopsTaskLogCU}
